package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20042ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.ProtCheckLabelStatusResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot20042CheckLabelStatus extends ProtBase {
	
	private final short iTaskCode20042 = 20042;
	private Gson gson;
	private ProtCheckLabelStatusResBean statusResBean;
	private Prot20042ReqBean reqBean;
	private String consume_code;
	
	public Prot20042CheckLabelStatus() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	/*public String getJsonData() {
		return jsonData;
	}*/
	public ProtCheckLabelStatusResBean getResBean(){
		return this.statusResBean;
	}
	
	public void checkLabelStatus(SocketCreate create, Prot20042ReqBean reqBean, String consume_code) throws IOException {
		this.reqBean = reqBean; 
		this.consume_code = consume_code;
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20042ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20042, "开始提交激活信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20042, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20042, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			statusResBean = gson.fromJson(jsonData, ProtCheckLabelStatusResBean.class);
			statusResBean.setLabel_id(reqBean.getLabel_id());
			statusResBean.setConsume_code(consume_code);
		}
		System.err.println("resBean: " + statusResBean.toString());
		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20042ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		debugLog(iTaskCode20042, "发送的数据格式：" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20042, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
